package	jp.co.sds_corp.fixconnect.logger;

import	jp.co.sds_corp.fixconnect.FIXException;
import	jp.co.sds_corp.fixconnect.message.FIXMessage;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

public class SimpleLogger extends AbstractMessageLogger
{
	static final CmnLogger logger = CmnLogFactory.getLogger();

	public void init( IConfiguration config ) throws Exception {
		super.init( config );
	}

	public void log( Direction direction, FIXMessage msg )
		throws FIXException
	{
		if ( !isLogging( msg )) {
			return;
		}

		String log = direction + "\n" + msg.toString();
		if ( isDump()) {
			try {
				log += "\n" + dump( msg );
			} catch ( Exception ex ) {
				throw( new FIXException( "log dump error", ex ));
			}
		}
		logger.debug( this, log );
	}

	public void close() {
	}

}
