package	jp.co.sds_corp.fixconnect.test;

import jp.co.sds_corp.fixconnect.FIXException;
import jp.co.sds_corp.fixconnect.message.FIXMessage;
import jp.co.sds_corp.fixconnect.message.IMessageReceiver;
import jp.co.sds_corp.fixconnect.message.MessageReceiveEvent;
import jp.co.sds_corp.fixconnect.transport.FIXSession;
import jp.co.sds_corp.fixconnect.transport.ITransportEventListener;
import jp.co.sds_corp.fixconnect.transport.Initiator;
import jp.co.sds_corp.fixconnect.transport.TransportEvent;
import jp.co.sds_corp.util.config.DOMConfiguration;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

public class DummyClient implements IMessageReceiver, ITransportEventListener
{
	static final CmnLogger logger = CmnLogFactory.getLogger();
	Initiator initiator;

	public void init() throws Exception {
		DOMConfiguration doc = DOMConfiguration.findResource( "test.xml" );
		initiator = new Initiator();
		IConfiguration config = doc.getChild("Client");
		initiator.init( config );

		initiator.addMessageReceiver( this );
		initiator.addEventListener( this );
	}

	public void onMessage( MessageReceiveEvent ev ) {
		FIXMessage msg = ev.getMessage();
		logger.debug( this, "message: " + msg );
	}

	public void onEvent( TransportEvent ev ) {
		logger.debug( this, "event:" + ev );
	}

	public void onException( FIXException ex ) {
		logger.debug( this, "exception:" + ex, ex );
	}

	public void start() throws Exception {
		FIXMessage msg;
		initiator.start();
		initiator.logon();
		initiator.logout();
	}

	public void start2() throws Exception {
		FIXMessage msg;
		initiator.start();
		FIXSession session = initiator.getSession();
		msg = session.getParser().createMessage( "A" );
		msg.setField( "SenderCompID", "CLIEN=T" );
		initiator.send( msg );
		initiator.logon();
		Thread.sleep( 3000 );
		msg = session.getParser().createMessage( "1" );
		msg.setField( "SenderCompID", "CLIENT2" );
		initiator.send( msg );
	}

	public void stop() throws Exception {
		initiator.stop();
	}

	public static void main( String[] args ) {
		try {
			DummyClient obj = new DummyClient();
			obj.init();
			obj.start();
			obj.stop();
		} catch ( Exception ex ) {
			ex.printStackTrace();
		}
	}

}

